function buildCameras_DFD(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end

dres=3;
nn=35;mm=36*dres;


n=33;

min_w_len1=0;
add_w_len1=5;
min_w_len2=2;
add_w_len2=8;


ind=0;
smps_num=20;

for s=1:smps_num 
   

    %to speed, allows sampling only a subset of the camera
    %parameters in the list below
    if (rand>smpper)
      continue
    end
 
    ind=ind+1;

    w2=ceil(rand*add_w_len2+min_w_len2);

    w2=w2*2+1;
 

 
    reslen2=floor((n-w2)/2);

    codes{1}=zeros(n,1); 
    codes{1}(reslen2+1:reslen2+w2)=1/2;
    codes{2}=zeros(n,1); 
    codes{2}(reslen2+1:reslen2+w2)=1/2;

    ang=rand(1,2)*2-1;
    eval(sprintf('save %s/codes_DFD%03d.mat codes ang',outdirname,ind))

    T=buildLPTFromCode(nn,mm,dres,codes,ang,0);
    T=sparse(T);

    eval(sprintf('save %s/Tmat_DFD%03d.mat T',outdirname,ind))

end
