function buildCameras_Stereo(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end
dres=3;
nn=35;mm=36*dres;

n=33;

min_w_len=2;
add_w_len=8;
min_d_len=5;
ind=0;
smps_num=30;

for s=1:smps_num

   %to speed, allows sampling only a subset of the camera
   %parameters in the list below
   if (rand>smpper)
     continue
   end
 
   ind=ind+1;
   w1=ceil(rand*add_w_len+min_w_len);     
   w2=ceil(rand*add_w_len+min_w_len); 
 
   add_d_len=n-4-w1-w2-min_d_len;
   d=ceil(rand*add_d_len+min_d_len); 
   
   tlen=w1+w2+d;
   reslen=floor((n-tlen)/2);
   codes{1}=zeros(n,1); 
   codes{1}(reslen+1:reslen+w1)=1;
   codes{2}=zeros(n,1); 
   codes{2}(d+w1+reslen+1:reslen+tlen)=1;
   ang(1)=0;
   ang(2)=0;

   
   eval(sprintf('save %s/codes_stereo%03d.mat codes ang',outdirname,ind))
    
    
   T=buildLPTFromCode(nn,mm,dres,codes,ang,0);
   T=sparse(T);

   eval(sprintf('save %s/Tmat_stereo%03d.mat T',outdirname,ind))
end
