function buildCameras_wfc(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end


n0=33;
n=35;
dres=3;
m=36*dres;
nstp=20*dres;

curve_vals{1}=ones(nstp*n0+1,1);
cords=([1:nstp*n0+1]-nstp*n0/2-1)/nstp;

%a_vals=[0.5,1,2,3,5,10];
a_vals=[5,10,20,30];

b_vals=[-16:2:8];



ind=0;
clear codes
for a=1:length(a_vals)
  for b=1:length(b_vals)

    %to speed, allows sampling only a subset of the camera
    %parameters in the list below
    if (rand>smpper)
     continue
    end
 
   
    ind=ind+1; 
   

    curve_cords{1}=2*n0*((cords-b_vals(b))/n0).^2*a_vals(a);
    T=buildLPTFromCurve(n,m,dres,curve_cords,curve_vals,0);

    ang=0;
    eval(sprintf('save %s/codes_wfc%03d.mat curve_cords curve_vals  ang',outdirname,ind)) 
    eval(sprintf('save %s/Tmat_wfc%03d.mat T',outdirname,ind)) 

  end
end
