function O=buildOkMat(slopes_map,s_num,slopeind)

[n,m]=size(slopes_map);
s_vals=unique(slopes_map);

s_len=length(s_vals);
if (~exist('s_num','var'))
  s_num=s_len;
end
if (~exist('slopeind','var'))
  slopeind=1;
end

[x_grid,y_grid]=meshgrid([1:m],[1:n]-ceil(n/2));
inds=[1:n*m];
len=0;
rows_len=0;
for d=1:s_len
  t_slope=s_vals(d);
  layer_inds=find(slopes_map==t_slope);
  t_len=length(layer_inds);
  new_x_grid=mod((x_grid-t_slope*y_grid)-1,m);
  new_x_grid(find(new_x_grid>(m-0.1^10)))=0;
  new_x_grid=new_x_grid+1;
  new_x_grid1=floor(new_x_grid);
  new_x_grid2=mod(new_x_grid1,m)+1;
  a=new_x_grid-new_x_grid1;
 
  col_inds(len+1:len+t_len)=new_x_grid1(layer_inds(:))+(d-1)*m;
  vals(len+1:len+t_len)=1-a(layer_inds(:));
  row_inds(len+1:len+t_len)=layer_inds(:);
  len=len+t_len;
  col_inds(len+1:len+t_len)=new_x_grid2(layer_inds(:))+(d-1)*m;
  vals(len+1:len+t_len)=a(layer_inds(:)); 
  row_inds(len+1:len+t_len)=layer_inds(:);
  len=len+t_len;
end

O=sparse(row_inds(:),col_inds(:)+(slopeind-1)*m,vals(:),n*m,s_num*m);
