function [opt_params_row_ind,opt_params_row_experr,opt_params_all_ind,opt_params_all_experr]=evalCams(cameraTypes,camera_data_dir,LF_data_dir,sig_noise,out_data,max_group_len)

mean_d=0.002;

dres=3;
n=35; m=36*dres;
dsmp=dres;
smpvar=dsmp*0.33;


dl=dir([LF_data_dir,'/*.mat']);
lf_len=length(dl);

for c=1:length(cameraTypes)
  dc=dir([camera_data_dir,'/Tmat_',cameraTypes{c},'*.mat']);
  cam_len=length(dc);  
  
  ci_list=randperm(cam_len);
  ci_list=ci_list(1:min(cam_len,max_group_len));
  
 
  tdir=dir(out_data);
  if (length(tdir)>0)
    eval(['!load ',out_data])
  end
 
  experr{c}=zeros(n,cam_len,lf_len);
  experr_all{c}=zeros(cam_len,1);
  experr_row{c}=zeros(cam_len,1);
  
  for ci=ci_list(:)'
    [c,ci]
   
    eval(sprintf('load %s/%s',camera_data_dir,dc(ci).name))
     
    for li=1:lf_len
        
      %tic
      
      eval(sprintf('load %s/%s',LF_data_dir,dl(li).name))
      
      slopes_len=length(Os);
    
      
      clear Fs
      for i=1:slopes_len
        Fs{i}=T*Os{i};
      end
      LF=reshape(Os{1}*x0L(:),n,m);
      true_s=1;
      weight_s=ones(1,slopes_len);

      
      [lkv_d,eng,Aeng,vars,mse_x]=getMSE1crows(x0L,m/dres,true_s,weight_s,Fs,Os,sig_noise,mean_d,1);
                   
      experr{c}(:,ci,li)=Aeng;
     
                   
      %toc;
        
    end

    [bv,b_row]=min(mean(experr{c}(:,ci,:),3),[],1);
    experr_row{c}(ci)=bv;
     
    meanv=experr_row{c};
    [mv,mi]=min(meanv+(meanv<0.001)*10000);
    opt_params_row_ind(c)=mi;    
    opt_params_row_experr(c)=mv;
 
   
    experr_all{c}(ci)=sum(mean(experr{c}(:,ci,:),3),1);
      
    meanv=experr_all{c};
    [mv,mi]=min(meanv+(meanv<0.001)*10000);
  
    opt_params_all_ind(c)=mi;    
    opt_params_all_experr(c)=mv;

       
    eval(sprintf('save %s experr_all experr experr_row opt_params_all_experr opt_params_all_ind opt_params_row_ind opt_params_row_experr',out_data))

  end


end
