%we build a matrix O, expressing the light field as a function of slopes_len 
%central rows (one central row per layer). we do that for the true 
%slope-field, and for some slop-fields permutations

function [Os]=permSlopesToOk(s_vals,depthj,n,m,mind,maxd,dres,frac_d,rand_fracs,smp_const,jstpsC,sstpsC)

if (~exist('frac_d','var'))
  frac_d=1;
end
if ~exist('rand_fracs','var')
   rand_fracs=1;
end
if ~exist('smp_const','var')
   smp_const=0;
end


dvals=[mind:frac_d:maxd];
if (~exist('jstpsC','var'))
  jstp1d=ceil(rand*dres/3+dres/3);
  jstp2d=ceil(rand*dres+dres);
  jstp1u=ceil(rand*dres/3+dres/3);
  jstp2u=ceil(rand*dres+dres);
  jstpsC={[-jstp2d,-jstp1d,jstp1u,jstp2u]};
end
if (~exist('sstpsC','var'))
  rand_frac1=frac_d*rand/3+rand/3;
  rand_frac2=frac_d*rand/3+rand/3;
  sstpsC={[-rand_frac1,rand_frac2]};
end
uslopes=unique(round(s_vals*10^10))/10^10;
s_num=length(uslopes);

ind=1;
Os{ind}=get_OkFromRow(s_vals,depthj,n,m,s_num);

pdepthj=[0,depthj(1:end-1)];
ndepthj=[depthj(2:end),m];
for i=1:length(depthj)
   for j=1:length(jstpsC{1})
      tdepthj=depthj; tdepthj(i)=tdepthj(i)+jstpsC{1}(j);
      if (tdepthj(i)<(pdepthj(i)+1))
         tdepthj(i)=pdepthj(i);
      end
      if (tdepthj(i)>(ndepthj(i)-1))
         tdepthj(i)=ndepthj(i);
      end
      ind=ind+1;
      Os{ind}=get_OkFromRow(s_vals,tdepthj,n,m,s_num);
   end
end
[unique_s,unique_map,unique_imap]=unique(round(s_vals*10^10));
unique_s=unique_s/10^10;

for i=1:length(unique_s)
   for j=1:length(sstpsC{1})
     ts_vals= s_vals;
     tval=s_vals(unique_map(i));
     ts_vals(find(unique_imap==i))=min(max(tval+sstpsC{1}(j),mind),maxd);
     
     ind=ind+1;
     Os{ind}=get_OkFromRow(ts_vals,depthj,n,m,s_num);

   end
end



for d=dvals
  r=rand;
  if ((smp_const)&(min(abs(d-uslopes))>=frac_d)&(r<(2/3)))
    continue
  end
  ind=ind+1;

  Os{ind}=get_OkFromRow([d],[],n,m,s_num);
end



ind=1;
sOs{1}=Os{1};
maps_len=length(Os);

for i=2:maps_len
  clear dd
  for j=1:i-1
    dd(j)=sum(sum(abs(Os{i}-Os{j})));
  end
  if (min(dd)>0.01)
     ind=ind+1;
    sOs{ind}=Os{i};    
  end
end

Os=sOs;

