function buildCameras_coded(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end

dres=3;
nn=35;mm=36*dres;

n=33;
focus=[-3,3]/3;
sym=[1,1];
smps_num=40;
min_len=11;
add_len=n-min_len-2;

ind=0;
clear codes
for f=1:length(focus)
  for s=1:smps_num

    %to speed, allows sampling only a subset of the camera
    %parameters in the list below
    if (rand>smpper)
      continue
    end
 
    

    ind=ind+1; 
    tlen=ceil(rand*add_len+min_len);
    htlen=floor((tlen-1)/2);
    tlen=htlen*2+1;
    reslen=floor((n-tlen)/2);
    tcode=round(rand(1,tlen));
    if (sym(f))
      tcode(1:htlen)=tcode(end:-1:end-htlen+1);
    end
    codes{1}=zeros(n,1); 
    codes{1}(reslen+1:reslen+tlen)=tcode;
    ang=focus(f);
    eval(sprintf('save %s/codes_coded%03d.mat codes ang',outdirname,ind)) 

    T=buildLPTFromCode(nn,mm,dres,codes,ang,0);
    T=sparse(T);

    eval(sprintf('save %s/Tmat_coded%03d.mat T',outdirname,ind))


  end
end
