function buildCameras_lens(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end

dres=3;
nn=35;mm=36*dres;


n=33;
lens_width=[9,15,27];

focus=1;
ind=0;
clear codes
for f=1:length(focus)
 for w1=1:length(lens_width)
   %to speed, allows sampling only a subset of the camera
   %parameters in the list below
   if (rand>smpper)
     continue
   end
 
   ind=ind+1;
   tlen=lens_width(w1);
   reslen=floor((n-tlen)/2);
   codes{1}=zeros(n,1); 
   codes{1}(reslen+1:reslen+tlen)=1;
   ang=focus(f);
   eval(sprintf('save %s/codes_lens%03d.mat codes ang',outdirname,ind)) 

      
   T=buildLPTFromCode(nn,mm,dres,codes,ang,0);
   T=sparse(T);

   eval(sprintf('save %s/Tmat_lens%03d.mat T',outdirname,ind))

  end
end
