function buildCameras_plenoptic(outdirname,smpper)

if ~exist('smpper','var')
   smpper=1; 
end
dres=3;
nn=35;mm=36*dres;


n=33;
lens_width=[4,5,6,7,8];
view_res=[4];

ind=0;
for v=1:length(view_res)
for w1=1:length(lens_width)
   
   %to speed, allows sampling only a subset of the camera
   %parameters in the list below
   if (rand>smpper)
     continue
   end
 
   ind=ind+1;
   tw=lens_width(w1);
   tlen=tw*view_res(v);
   reslen=floor((n-tlen)/2);
   for i=1:view_res(v)
     codes{i}=zeros(n,1); 
     codes{i}(reslen+1+(i-1)*tw:reslen+i*tw)=1;
   end
   ang=zeros(1,length(codes));
   eval(sprintf('save %s/codes_plenoptic%03d.mat codes ang',outdirname,ind))

   T=buildLPTFromCode(nn,mm,dres,codes,ang,0);
   T=sparse(T);

   eval(sprintf('save %s/Tmat_plenoptic%03d.mat T',outdirname,ind))

end
end
