!mkdir LF_data
!mkdir LF_data/disc1
!mkdir LF_data/disc2
!mkdir LF_data/disc3
!mkdir LF_data/disc2N

!mkdir camera_data 


cameraTypes{1}='pinhole';
cameraTypes{2}='lens';
cameraTypes{3}='wfc';
cameraTypes{4}='coded';
cameraTypes{5}='DFD';
cameraTypes{6}='stereo';
cameraTypes{7}='plenoptic';

disp(['building LF data for disc 1'])
smpTestLF(1,-3,3,'LF_data/disc1');
disp(['building LF data for disc 2'])
smpTestLF(2,-3,3,'LF_data/disc2');
disp(['building LF data for disc 3'])
smpTestLF(3,-3,3,'LF_data/disc3');

disp(['building LF data for disc 2 narrow'])
smpTestLF(2,0,3,'LF_data/disc2N');
smpper=1;

cameraoutdirname='camera_data';

for c=1:length(cameraTypes)
   disp([num2str(c),': building camera params for ',cameraTypes{c}])
   eval(sprintf('buildCameras_%s(cameraoutdirname,smpper)',cameraTypes{c}))
end
