function T=buildLPTFromCode(n,m,dres,codes,ang,issps)

if(~exist('ang','var'))
  ang=0;
end
if (~exist('issps','var'))
  issps=1;
end

if (length(ang)==1)
   ang=repmat(ang,1,length(codes));
end
nstp=20*dres;

for k=1:length(codes)
  code=codes{k};
  curve_vals{k}=zeros(nstp*length(code)+1,1);

  curve_cords{k}=[1:nstp*length(code)+1]-nstp*length(code)/2-1;
  curve_cords{k}=curve_cords{k}*ang(k)/nstp;

  for i=1:length(code)
    if (code(i))
     curve_vals{k}((i-1)*nstp+2:i*nstp)=1*code(i);
     curve_vals{k}([(i-1)*nstp+1,i*nstp+1])=curve_vals{k}([(i-1)*nstp+1,i*nstp+1])+0.5*code(i);
    end
  end

end

T=buildLPTFromCurve(n,m,dres,curve_cords,curve_vals,issps);
