dres=3;
n=35; m=36*dres;

cameraTypes{1}='pinhole';
cameraTypes{2}='lens';
cameraTypes{3}='wfc';
cameraTypes{4}='coded';
cameraTypes{5}='DFD';
cameraTypes{6}='stereo';
cameraTypes{7}='plenoptic';

evaluate_optimized=1;

if (~evaluate_optimized)
  cameradir1='camera_data';
  cameradir2='camera_data';
  cameradir3='camera_data';
else
  cameradir1='opt_camera_data_g_disc1';
  cameradir2='opt_camera_data_g_disc2';
  cameradir3='opt_camera_data_g_disc3';
end


sig_noise=0.01;

out_data1='evalCams_g_disc1';
out_data2='evalCams_g_disc2';
out_data3='evalCams_g_disc3';


max_group_len=8;

[op_row_ind1,op_row_experr1,op_all_ind1,op_all_experr1]=evalCamsGauss(cameraTypes,cameradir1,'LF_data/disc1',sig_noise,out_data1,max_group_len)

[op_row_ind2,op_row_experr2,op_all_ind2,op_all_experr2]=evalCamsGauss(cameraTypes,cameradir2,'LF_data/disc2',sig_noise,out_data2,max_group_len)

save evalCam2res op_row_ind2 op_row_experr2 op_all_ind2 op_all_experr2
max_group_len=15;
[op_row_ind3,op_row_experr3,op_all_ind3,op_all_experr3]=evalCamsGauss(cameraTypes,cameradir3,'LF_data/disc3',sig_noise,out_data3,max_group_len)




barmat_row(:,1)=op_row_experr1(:);
barmat_row(:,2)=op_row_experr2(:);
barmat_row(:,3)=op_row_experr3(:);
barmat_all(:,1)=op_all_experr1(:);
barmat_all(:,2)=op_all_experr2(:);
barmat_all(:,3)=op_all_experr3(:);
barmat_all=barmat_all/(n*m);
barmat_row=barmat_row/m;


outname_row='figs/experr_g_row_vardisc.eps';
outname_all='figs/experr_g_all_vardisc.eps';


dataType{1}='No depth discontinuities';
dataType{2}='Modest depth discontinuities';
dataType{3}='Many depth discontinuities';


plotBars(barmat_row,cameraTypes,dataType,outname_row)
plotBars(barmat_all,cameraTypes,dataType,outname_all)

