dres=3;
n=35; m=36*dres;

cameraTypes{1}='pinhole';
cameraTypes{2}='lens';
cameraTypes{3}='wfc';
cameraTypes{4}='coded';
cameraTypes{5}='DFD';
cameraTypes{6}='stereo';
cameraTypes{7}='plenoptic';



evaluate_optimized=1;

if (~evaluate_optimized)
  cameradirN='camera_data';
else
  cameradirN='opt_camera_data_disc2N';
end

sig_noise=0.01;

max_group_len=80;


out_data2N='evalCams_disc2N';

[op_row_ind2N,op_row_experr2N,op_all_ind2N,op_all_experr2N]=evalCams(cameraTypes,cameradirN,'LF_data/disc2N',sig_noise,out_data2N,max_group_len)



if (~evaluate_optimized)%we assume here evalCams_LFP_DepthComp.m was run first
  load evalCam2res 
else
  load evalCam2res_opt 
end

barmat_dr_all(:,1)=op_all_experr2N(:);
barmat_dr_all(:,2)=op_all_experr2(:);
barmat_dr_row(:,1)=op_row_experr2N(:);
barmat_dr_row(:,2)=op_row_experr2(:);

barmat_dr_all=barmat_dr_all/(n*m);
barmat_dr_row=barmat_dr_row/m;


outname_dr_row='figs/experr_row_vardrange.eps';
outname_dr_all='figs/experr_all_vardrange.eps';

dataType_dr{1}='ang=45';
dataType_dr{2}='ang=90';

plotBars(barmat_dr_row,cameraTypes,dataType_dr,outname_dr_row)
plotBars(barmat_dr_all,cameraTypes,dataType_dr,outname_dr_all)

