dres=3;
n=35; m=36*dres;

cameraTypes{1}='pinhole';
cameraTypes{2}='lens';
cameraTypes{3}='wfc';
cameraTypes{4}='coded';
cameraTypes{5}='DFD';
cameraTypes{6}='stereo';
cameraTypes{7}='plenoptic';

evaluate_optimized=1;

if (~evaluate_optimized)
  cameradirn2='camera_data';
  cameradirn3='camera_data';
else
  cameradirn2='opt_camera_data_disc2_n2';
  cameradirn3='opt_camera_data_disc2_n3';
end

sig_noise=0.01;

max_group_len=80;





out_data2_n2='evalCams_disc2_n2';
out_data2_n3='evalCams_disc2_n3';

sig_noise2=0.03;
sig_noise3=0.1;

[op_row_ind2_n2,op_row_experr2_n2,op_all_ind2_n2,op_all_experr2_n2]=evalCams(cameraTypes,cameradirn2,'LF_data/disc2',sig_noise2,out_data2_n2,max_group_len)
[op_row_ind2_n3,op_row_experr2_n3,op_all_ind2_n3,op_all_experr2_n3]=evalCams(cameraTypes,cameradirn3,'LF_data/disc2',sig_noise3,out_data2_n3,max_group_len)


if (~evaluate_optimized)%we assume here evalCams_LFP_DepthComp.m was run first
  load evalCam2res 
else
  load evalCam2res_opt 
end


barmat_noise_all(:,1)=op_all_experr2(:);
barmat_noise_all(:,2)=op_all_experr2_n2(:);
barmat_noise_all(:,3)=op_all_experr2_n3(:);
barmat_noise_row(:,1)=op_row_experr2(:);
barmat_noise_row(:,2)=op_row_experr2_n2(:);
barmat_noise_row(:,3)=op_row_experr2_n3(:);
barmat_noise_all=barmat_noise_all/(n*m);
barmat_noise_row=barmat_noise_row/m;

outname_noise_row='figs/experr_row_vardnoise.eps';
outname_noise_all='figs/experr_all_vardnoise.eps';

dataType_noise{1}='n=0.01';
dataType_noise{2}='n=0.03';
dataType_noise{3}='n=0.1';

plotBars(barmat_noise_row,cameraTypes,dataType_noise,outname_noise_row)
plotBars(barmat_noise_all,cameraTypes,dataType_noise,outname_noise_all)

