function [eng,sumsigs,mse_x]=getGausMSE(true_x,T,sig_noise,mean_d,n,m,dres)

K=size(true_x,2);

nn=n*dres;
avgM=getConvMat(m,nn,ones(dres,1)/dres,[0 0 1 dres-1],1);
avgM=avgM(1:dres:end,:);
bT=T*avgM;
Gx=getConvMat(m,nn,[-1 1],[0 1 0 0],1);
Gy=getConvMat(m,nn,[-1;1],[0 0 0 1],1);
Gxx=getConvMat(m,nn,[-1 2 -1],[-1 1 0 0],1);
Gyy=getConvMat(m,nn,[-1;2;-1],[0 0 -1 1],1);
Gxy=getConvMat(m,nn,[1,-1;-1,1],[0 1 0 1],1);
G=[Gx;Gy;Gxx;Gyy;Gxy];

dsmp=dres;
smpvar=dsmp*0.33;
f0=exp(-0.5*[-dsmp:dsmp].^2/smpvar^2);
f0=conv2(f0,ones(1,dsmp));
f0=f0/sum(f0);
stpd=floor((length(f0)-dres)/2);
stpu=length(f0)-stpd-1;
LPM=getConvMat(m,n,f0(:)',[-stpd stpu 0 0],1);
LPM1=LPM*avgM;


N=m*nn;

iCov=(0.5/mean_d*G'*G+1/sig_noise^2*bT'*bT);

y=T*true_x;

Aeng=zeros(1,K);

T1=(1/sig_noise^2*bT);
 
  tic
  Cov=inv(full(iCov));
  toc
  %keyboard
  V1M=LPM1*Cov*T1';
  Cov=LPM1*Cov*LPM1';
  sumsigs=(diag(Cov));
  

 
  
  for j=1:K
  
     V1j=(V1M*y(:,j));

     e1=reshape((V1j-true_x(:,j)).^2+sumsigs,n,m);
     e1=sum(e1,2);
     eng(:,j)=e1;
     
    

     mse_x(:,j)=V1j;
 
  end 
 

mse_x=reshape(mse_x,n,m,K);
return

