function [lkv_d,eng,Aeng,sumsigs,mse_x]=getMSE(x,win_size,true_s,weight_s,Fs,Os,sig_noise,mean_d,smp_rate,marg_boundary)

if (~exist('smp_rate','var'))
  smp_rate=1;
end
if (~exist('marg_boundary','var'))
  marg_boundary=0;
end
S=length(Fs);
n=size(x,1);
dd=size(x,2);
m=n*dd;
K=size(x,3);

mm=size(Fs{1},1);
nn=size(Os{1},1)/n;


hd=floor((mm-win_size)/2);
hu=ceil((mm-win_size)/2);
yinds=[1+hd:mm-hu];
dlen=round(n/mm);
hd1=floor((n-win_size*dlen)/2);
hu1=ceil((n-win_size*dlen)/2);
xinds=[];
for d=1:dd
  xinds=[xinds,(d-1)*n+[1+hd1:n-hu1]];
end
oxinds=[1:size(Os{1},1)];

x0=reshape(x,m,K);
mse_x=zeros(nn*n,K);

for s=1:S
   vp=full(sum(Fs{s}(:,xinds),2)./max(sum(Fs{s},2),0.00001));
   [sv,si]=sort(-vp);
   si=sort(si(1:length(yinds)));
   smp_si=intersect(si,[1:smp_rate:mm]);
   yindsS{s}=si(:);
   smp_yindsS{s}=smp_si(:);
end


G1=getConvMat(1,n,[1;-1],[0 0 0 1],1);
G1(1)=G1(1)+0.0001;
G=[];
for d=1:dd
G=[G,sparse(size(G,1),n);sparse(n,size(G,2)),G1];
end

tse=1;
we=tse/mean_d;
we2=we*100;
we2=we*1000;



%keyboard
for s=1:S
 
  v_inds=yindsS{s}+m;
  m_inds=setdiff([1:mm+m],v_inds);

  F=Fs{s}; 

  iCxy=[1/sig_noise^2*F'*F+we*G'*G, -1/sig_noise^2*F';...
     -1/sig_noise^2*F, 1/sig_noise^2*speye(mm)];
 
  iCy=iCxy(v_inds,v_inds)-iCxy(v_inds,m_inds)*inv(iCxy(m_inds,m_inds))*iCxy(m_inds,v_inds);  

  
  [l,u,p]=lu(iCy);
  logdet_Cy(s)=-sum(log(abs(diag(u))));

  
  for j=1:K
    by=Fs{true_s(j)}*x0(:,j);
    y=by(yindsS{s},:);
    ylk(s,j)=-0.5*y'*iCy*y-logdet_Cy(s)/2;
  end
 
end

ylk=ylk+log(repmat(weight_s(:),[1,K]));

ylk=real(ylk);





for j=1:K
  for s=1:S
    lkv_d(s,j)=ylk(s,j)-sumExp(ylk(:,j));
  end
end







if (~marg_boundary)
  for s=1:S
    si=[1:mm];
    smp_si=intersect(si,[1:smp_rate:mm]);
    yindsS{s}=si(:);
    smp_yindsS{s}=smp_si(:);
  end
end

for j=1:K
  true_x(:,j)=Os{true_s(j)}(oxinds,:)*x0(:,j);
end
Aeng=zeros(nn,K);
eng=zeros(nn,S,K);
for s=1:S
  F=Fs{s};
  F=F(smp_yindsS{s},:);

  Cxcy=inv(1/sig_noise^2*F'*F+we*G'*G);

  V2M=1/sig_noise*Cxcy*F';
  V1M=1/sig_noise*V2M;
  sumsigs=(sum(((Os{s}(oxinds,:)*Cxcy).*Os{s}(oxinds,:)),2));

  V2=0;
  for j=1:K
     Fs0=Fs{true_s(j)};
     Fs0=Fs0(smp_yindsS{true_s(j)},:);
     V1j=Os{s}(oxinds,:)*(V1M*Fs0*x0(:,j));
     e1=reshape((V1j-true_x(:,j)).^2+sumsigs,nn,n);
     e1=sum(e1,2);

     eng(:,s,j)=e1;
     Aeng(:,j)=Aeng(:,j)+exp(lkv_d(s,j))* e1;

     mse_x(:,j)=mse_x(:,j)+exp(lkv_d(s,j))*V1j;
 
  end 
 
end
mse_x=reshape(mse_x,nn,n,K);
return
