function plotBars(barmat,cameraTypes,dataType,outname)

figure(1), cm=colormap;   

f=figure, bar(barmat); colormap(cm([34,39,46],:))
legend(dataType)

min_y=0.9*min(barmat(:));
max_y=median(barmat(:))*1.5;

disp_y=(max_y-min_y)*0.08;

axis([0 length(cameraTypes)+1 min_y max_y ])


max_hight=min((max(barmat,[],2)),max_y-disp_y*5);
cind=0;
for c=1:length(cameraTypes)
  cind=cind+1;
  t=text(cind-0.5,max_hight(cind)+disp_y,cameraTypes{c},'FontSize',20 );
end

cf=get(f,'children');
for i=1:length(cf)
   if(isfield(get(cf(i)),'FontSize'))
     set(cf(i),'fontSize',20)
   end
end

eval(['print -depsc ',outname])

